require_relative '../hash_wrap.rb'

class HashWrap
  # really a convenience method
  def self.of_json json
    vs = JSON.parse json, symbolize_names: true
    case vs
    when Array
      vs.map{|obj| new obj}
    when Hash
      new vs
    else
      raise "Cannot construct #{self.class} from json in #{json.inspect}"
    end
  end
end

# The String part of this can be overwritten by other requires in this gem, so
# use with caution.
module Kernel
  private def HashWrap arg
    case arg
    when String; HashWrap.of_json arg
    when Hash;   HashWrap.new arg
    end
  end
end
